apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ artifactory_name }}
  name: {{ artifactory_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ artifactory_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ artifactory_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ artifactory_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values:
                - {{ artifactory_name }}
                - {{ artifactory_name }}-slave
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values:
                  - {{ artifactory_name }}
                  - {{ artifactory_name }}-slave
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DB_TYPE
{% if artifactory_db_type == 'postgres' %}
          value: postgresql
        - name: DB_HOST
          value: {{ artifactory_pg_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_pg_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_pg_name }}
        - name: DB_PORT
          value: "5432"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_pg_name }}
{% elif artifactory_db_type in [ 'percona' ] %}
          value: mariadb
        - name: DB_HOST
          value: {{ artifactory_pc_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_pc_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_pc_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_pc_name }}
{% elif artifactory_db_type in [ 'mariadb', 'mysql' ] %}
          value: mariadb
        - name: DB_HOST
          value: {{ artifactory_ms_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_ms_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_ms_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_ms_name }}
{% endif %}
        - name: ARTIFACTORY_MASTER_KEY
          valueFrom:
            secretKeyRef:
              name: {{ artifactory_name }}
              key: master.key
        - name: HA_NODE_ID
          value: {{ artifactory_name }}
        - name: HA_IS_PRIMARY
          value: "true"
        - name: HA_MEMBERSHIP_PORT
          value: "10042"
        - name: EXTRA_JAVA_OPTIONS
          value: "{{ artifactory_java_options | join(' ') }}"
{% if do_triggers == False or (opsimages | json_query("[?name=='artifactory'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='artifactory'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /artifactory/webapp/#/login
            port: 8081
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 10
        name: artifactory
        ports:
        - containerPort: 8081
        - containerPort: 10042
        readinessProbe:
          httpGet:
            path: /artifactory/webapp/#/login
            port: 8081
          initialDelaySeconds: 30
          timeoutSeconds: 10
        resources:
          requests:
            cpu: "{{ artifactory_cpu_request }}"
            memory: "{{ artifactory_memory_request }}"
          limits:
            cpu: "{{ artifactory_cpu_limit }}"
            memory: "{{ artifactory_memory_limit }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8081
{% endif %}
        volumeMounts:
        - mountPath: /var/opt/jfrog/artifactory
          name: data
          subPath: artifactory
{% if artifactory_db_type == 'postgres' %}
        - mountPath: /opt/jfrog/artifactory/misc/db/postgresql.properties
          name: secrets
          subPath: postgresql.properties
{% elif artifactory_db_type in [ 'mariadb', 'mysql' ] %}
        - mountPath: /opt/jfrog/artifactory/misc/db/mariadb.properties
          name: secrets
          subPath: mariadb.properties
{% endif %}
{% if artifactory_subscription | default(False) %}
        - mountPath: /artifactory_extra_conf/artifactory.cluster.license
          name: secrets
          subPath: artifactory.cluster.license
{% endif %}
        - mountPath: /artifactory_extra_conf/binarystore.xml
          name: config
          subPath: binarystore.xml
      initContainers:
      - command:
        - sh
        - -c
        - rm -rf /var/opt/jfrog/artifactory/data/.lock
        image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
        name: remove-data-lock
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/opt/jfrog/artifactory
          name: data
          subPath: artifactory
      - command:
        - sh
        - -c
        - >
             until nc -z -w 2 {{ artifactory_pg_name }} 5432 \
               && echo database ok; do sleep 2; done
        image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
        name: wait-for-db
        securityContext:
          allowPrivilegeEscalation: false
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ artifactory_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
      - labelSelector:
          matchLabels:
            name: {{ artifactory_name }}-slave
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ artifactory_name }}-primary
      - name: secrets
        secret:
          secretName: {{ artifactory_name }}
      - configMap:
          name: {{ artifactory_name }}
        name: config
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='artifactory'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - artifactory
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='artifactory'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
